"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Statements_1 = require("./Statements");
var Factory = /** @class */ (function () {
    function Factory(options) {
        this.options = options;
        this.render = Statements_1.Statements.get(this.options)
            .append("var " + (options.elVarName || 'el') + " = __el__;")
            .append("var " + (options.ctxVarName || 'ctx') + " = __ctx__;");
        this.wrapper = Statements_1.Statements.get(this.options)
            .append('var fcOpenElement = funclate.openElement;')
            .append('var fcCloseElement = funclate.closeElement;')
            .append('var fcVoidElement = funclate.voidElement;')
            .append('var fcContent = funclate.content;')
            .append('var fcText = funclate.text;')
            .append('var fcComment = funclate.comment;');
    }
    Factory.prototype.appendOpenElement = function (name, attrs, props, opts) {
        this.render.append("fcOpenElement('" + name + "', " + attrs + ", " + props + ", " + opts + ");");
        return this;
    };
    Factory.prototype.appendCloseElement = function () {
        this.render.append("fcCloseElement();");
        return this;
    };
    Factory.prototype.appendVoidElement = function (name, attrs, props, opts) {
        this.render.append("fcVoidElement('" + name + "', " + attrs + ", " + props + ", " + opts + ");");
        return this;
    };
    Factory.prototype.appendText = function (text) {
        this.render.append("fcText(" + text + ");");
        return this;
    };
    Factory.prototype.appendComment = function (text) {
        this.render.append("fcComment(" + text + ");");
        return this;
    };
    Factory.prototype.appendContent = function () {
        this.render.append("fcContent();");
        return this;
    };
    Factory.prototype.append = function (statement) {
        this.render.append(statement);
        return this;
    };
    Factory.prototype.toFunction = function () {
        var wrapper = this.wrapper
            .append('return function (__el__, __ctx__) {')
            .append(this.render.join()).append('}')
            .join();
        if (this.options.output === 'string') {
            return "function (funclate) {" + wrapper + "}";
        }
        return new Function('funclate', wrapper);
    };
    return Factory;
}());
exports.Factory = Factory;
