"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var FcTagHandler_1 = require("./FcTagHandler");
/**
 * A funclate's tag implementing a forEach loop.
 * @example
 * <fc-each items="el.items">
 *     <li>{{ index }}/{{ all.length }} - {{ item }}</li>
 * </fc-each>
 */
var FcEachTagHandler = /** @class */ (function (_super) {
    __extends(FcEachTagHandler, _super);
    function FcEachTagHandler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FcEachTagHandler.prototype.startTag = function (factory, name, attributes, options) {
        var itemsVar = attributes['fc-items'] ? attributes['fc-items'] : '[]';
        var itemVar = attributes['fc-item'] ? attributes['fc-item'] : 'item';
        var indexVar = attributes['fc-index'] ? attributes['fc-index'] : 'index';
        var allVar = attributes['fc-all'] ? attributes['fc-all'] : 'all';
        factory.append(itemsVar + ".forEach(function (" + itemVar + ", " + indexVar + ", " + allVar + ") {");
    };
    FcEachTagHandler.prototype.endTag = function (factory, name, options) {
        factory.append('});');
    };
    return FcEachTagHandler;
}(FcTagHandler_1.FcTagHandler));
exports.FcEachTagHandler = FcEachTagHandler;
