"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var FcTagHandler_1 = require("./FcTagHandler");
/**
 * A funclate's tag implementing a if clause.
 * @example
 * <fc-if condition="el.foo === 'bar'">
 *     <span>foo is bar</span>
 * </fc-if>
 */
var FcIfTagHandler = /** @class */ (function (_super) {
    __extends(FcIfTagHandler, _super);
    function FcIfTagHandler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FcIfTagHandler.prototype.startTag = function (factory, name, attributes, options) {
        var condition = attributes['fc-condition'] ? attributes['fc-condition'] : 'false';
        factory.append("if (" + condition + ") {");
    };
    FcIfTagHandler.prototype.endTag = function (factory, name, options) {
        factory.append('}');
    };
    return FcIfTagHandler;
}(FcTagHandler_1.FcTagHandler));
exports.FcIfTagHandler = FcIfTagHandler;
