"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Statements_1 = require("./Statements");
var FcTagHandler = /** @class */ (function () {
    function FcTagHandler() {
    }
    /**
     * Invoked when starting tag of the element is found.
     * @param {Factory} factory
     * @param {string} name
     * @param {Map<string>} attributes
     * @param {ParserOptions} options
     */
    FcTagHandler.prototype.startTag = function (factory, name, attributes, options) {
        var fcAttrs = Statements_1.Statements.get(options);
        var fcProps = Statements_1.Statements.get(options);
        var fcOpts = Statements_1.Statements.get(options);
        Object.keys(attributes).forEach(function (attName) {
            var handler = options.attHandlers[attName] ? options.attHandlers[attName] : options.attHandlers['*'];
            if (handler) {
                handler.handle(attName, attributes[attName], fcAttrs, fcProps, fcOpts, options);
            }
        });
        if (options.selfClosingElements.indexOf(name) > -1) {
            factory.appendVoidElement(name, "[" + fcAttrs.join(',') + "]", "[" + fcProps.join(',') + "]", "[" + fcOpts.join(',') + "]");
        }
        else {
            factory.appendOpenElement(name, "[" + fcAttrs.join(',') + "]", "[" + fcProps.join(',') + "]", "[" + fcOpts.join(',') + "]");
        }
    };
    /**
     * Invoked when ending tag of the element is found.
     * @param {Factory} factory
     * @param {string} name
     * @param {ParserOptions} options
     */
    FcTagHandler.prototype.endTag = function (factory, name, options) {
        if (options.selfClosingElements.indexOf(name) < 0) {
            factory.appendCloseElement();
        }
    };
    return FcTagHandler;
}());
exports.FcTagHandler = FcTagHandler;
